OpenMPI 0.1.1

- Main Page
- Related Pages
- Modules
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Data Structures | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Static Protected Member Functions
Comm Class Referenceabstract
Inheritance diagram for Comm:

## Data Structures
struct | keyval_intercept_data_t

## Public Types
typedef void | Errhandler_function (Comm &, int *,...)
typedef Errhandler_function Errhandler_fn | __mpi_interface_deprecated__ ("MPI::Comm::Errhandler_fn was deprecated in MPI-2.2; use MPI::Comm::Errhandler_function instead")
typedef int | Copy_attr_function (const Comm &oldcomm, int comm_keyval, void *extra_state, void *attribute_val_in, void *attribute_val_out, bool &flag)
typedef int | Delete_attr_function (Comm &comm, int comm_keyval, void *attribute_val, void *extra_state)

## Public Member Functions
| Comm (const Comm_Null &data)
| Comm (const Comm &data)
| Comm (MPI_Comm data)
virtual void | Send (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual void | Recv (void *buf, int count, const Datatype &datatype, int source, int tag, Status &status) const
virtual void | Recv (void *buf, int count, const Datatype &datatype, int source, int tag) const
virtual void | Bsend (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual void | Ssend (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual void | Rsend (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual Request | Isend (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual Request | Ibsend (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual Request | Issend (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual Request | Irsend (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual Request | Irecv (void *buf, int count, const Datatype &datatype, int source, int tag) const
virtual bool | Iprobe (int source, int tag, Status &status) const
virtual bool | Iprobe (int source, int tag) const
virtual void | Probe (int source, int tag, Status &status) const
virtual void | Probe (int source, int tag) const
virtual Prequest | Send_init (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual Prequest | Bsend_init (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual Prequest | Ssend_init (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual Prequest | Rsend_init (const void *buf, int count, const Datatype &datatype, int dest, int tag) const
virtual Prequest | Recv_init (void *buf, int count, const Datatype &datatype, int source, int tag) const
virtual void | Sendrecv (const void *sendbuf, int sendcount, const Datatype &sendtype, int dest, int sendtag, void *recvbuf, int recvcount, const Datatype &recvtype, int source, int recvtag, Status &status) const
virtual void | Sendrecv (const void *sendbuf, int sendcount, const Datatype &sendtype, int dest, int sendtag, void *recvbuf, int recvcount, const Datatype &recvtype, int source, int recvtag) const
virtual void | Sendrecv_replace (void *buf, int count, const Datatype &datatype, int dest, int sendtag, int source, int recvtag, Status &status) const
virtual void | Sendrecv_replace (void *buf, int count, const Datatype &datatype, int dest, int sendtag, int source, int recvtag) const
virtual Group | Get_group () const
virtual int | Get_size () const
virtual int | Get_rank () const
virtual Comm & | Clone () const =0
virtual void | Free (void)
virtual bool | Is_inter () const
virtual void | Barrier () const
virtual void | Bcast (void *buffer, int count, const Datatype &datatype, int root) const
virtual void | Gather (const void *sendbuf, int sendcount, const Datatype &sendtype, void *recvbuf, int recvcount, const Datatype &recvtype, int root) const
virtual void | Gatherv (const void *sendbuf, int sendcount, const Datatype &sendtype, void *recvbuf, const int recvcounts[], const int displs[], const Datatype &recvtype, int root) const
virtual void | Scatter (const void *sendbuf, int sendcount, const Datatype &sendtype, void *recvbuf, int recvcount, const Datatype &recvtype, int root) const
virtual void | Scatterv (const void *sendbuf, const int sendcounts[], const int displs[], const Datatype &sendtype, void *recvbuf, int recvcount, const Datatype &recvtype, int root) const
virtual void | Allgather (const void *sendbuf, int sendcount, const Datatype &sendtype, void *recvbuf, int recvcount, const Datatype &recvtype) const
virtual void | Allgatherv (const void *sendbuf, int sendcount, const Datatype &sendtype, void *recvbuf, const int recvcounts[], const int displs[], const Datatype &recvtype) const
virtual void | Alltoall (const void *sendbuf, int sendcount, const Datatype &sendtype, void *recvbuf, int recvcount, const Datatype &recvtype) const
virtual void | Alltoallv (const void *sendbuf, const int sendcounts[], const int sdispls[], const Datatype &sendtype, void *recvbuf, const int recvcounts[], const int rdispls[], const Datatype &recvtype) const
virtual void | Alltoallw (const void *sendbuf, const int sendcounts[], const int sdispls[], const Datatype sendtypes[], void *recvbuf, const int recvcounts[], const int rdispls[], const Datatype recvtypes[]) const
virtual void | Reduce (const void *sendbuf, void *recvbuf, int count, const Datatype &datatype, const Op &op, int root) const
virtual void | Allreduce (const void *sendbuf, void *recvbuf, int count, const Datatype &datatype, const Op &op) const
virtual void | Reduce_scatter (const void *sendbuf, void *recvbuf, int recvcounts[], const Datatype &datatype, const Op &op) const
virtual void | Disconnect ()
virtual void | Get_name (char *comm_name, int &resultlen) const
virtual void | Set_name (const char *comm_name)
virtual int | Get_topology () const
virtual void | Abort (int errorcode)
virtual void | Set_errhandler (const Errhandler &errhandler)
virtual Errhandler | Get_errhandler () const
void | Call_errhandler (int errorcode) const
virtual void | Set_attr (int comm_keyval, const void *attribute_val) const
virtual bool | Get_attr (int comm_keyval, void *attribute_val) const
virtual void | Delete_attr (int comm_keyval)
Public Member Functions inherited from Comm_Null
| Comm_Null (const Comm_Null &data)
| Comm_Null (MPI_Comm data)
bool | operator== (const Comm_Null &data) const
bool | operator!= (const Comm_Null &data) const
| operator MPI_Comm () const

## Static Public Member Functions
static int | Compare (const Comm &comm1, const Comm &comm2)
static Intercomm | Get_parent ()
static Intercomm | Join (const int fd)
static Errhandler | Create_errhandler (Comm::Errhandler_function *function)
static int | Create_keyval (Copy_attr_function *comm_copy_attr_fn, Delete_attr_function *comm_delete_attr_fn, void *extra_state)
static int | Create_keyval (MPI_Comm_copy_attr_function *comm_copy_attr_fn, MPI_Comm_delete_attr_function *comm_delete_attr_fn, void *extra_state)
static int | Create_keyval (Copy_attr_function *comm_copy_attr_fn, MPI_Comm_delete_attr_function *comm_delete_attr_fn, void *extra_state)
static int | Create_keyval (MPI_Comm_copy_attr_function *comm_copy_attr_fn, Delete_attr_function *comm_delete_attr_fn, void *extra_state)
static void | Free_keyval (int &comm_keyval)
static int | NULL_COPY_FN (const Comm &oldcomm, int comm_keyval, void *extra_state, void *attribute_val_in, void *attribute_val_out, bool &flag)
static int | DUP_FN (const Comm &oldcomm, int comm_keyval, void *extra_state, void *attribute_val_in, void *attribute_val_out, bool &flag)
static int | NULL_DELETE_FN (Comm &comm, int comm_keyval, void *attribute_val, void *extra_state)

## Static Public Attributes
static opal_mutex_t | cxx_extra_states_lock

## Static Protected Member Functions
static int | do_create_keyval (MPI_Comm_copy_attr_function *c_copy_fn, MPI_Comm_delete_attr_function *c_delete_fn, Copy_attr_function *cxx_copy_fn, Delete_attr_function *cxx_delete_fn, void *extra_state, int &keyval)

## Additional Inherited Members
Protected Attributes inherited from Comm_Null
MPI_Comm | mpi_comm

The documentation for this class was generated from the following files:

- ompi/mpi/cxx/comm.h
- ompi/mpi/cxx/comm.cc
- ompi/mpi/cxx/comm_inln.h